% Simulation of LLP Load Balancing Controller 
% for a 6 Machine FMS
% by Veysel Gazi


clear;

Num_of_Mach = 6;
Look_Ahead = 4;
my_infty = 10000;

x0 = input('Please enter initial distribution of parts (6x1): ');

diary res1;

x(:,1) = x0;
g = [2 3;
     1 0;
     4 5;
     2 3;
     6 0;
     4 5];

L = fix(sum(x0)/Num_of_Mach);
Le = sum(x0) - L*Num_of_Mach;
xf = L*ones(Num_of_Mach,1);
%x0
disp('Balancing ...');
k = 1;
if (max(abs(xf-x(:,k))) == 1) & (sum(abs(xf-x(:,k))) == Le), 
  done = 1;
elseif (max(abs(xf-x(:,k))) == 0) & (Le == 0), 
  done = 1;
else
  done = 0;
end;

while ~done,  
  [dum,maxIndex] = max(x(:,k)); 
  [dum,minIndex] = min(x(:,k));
%  xt = x(:,k);  
%  xt(maxIndex) = xt(maxIndex) - 1;
%  xt(minIndex) = xt(minIndex) + 1;
  currentStates = x(:,k); currentMachines = maxIndex;
  nextStates = []; nextMachines = []; 
  states = currentStates; machines = currentMachines;
  currentCost = 0; nextCost = [];
  currentFather = []; nextFather = [];
  skip = 0;
  for i=1:Look_Ahead,
    if skip == 1,
      break;
    end;
    for j=1:length(currentMachines),
      if skip == 1,
        break;
      end;
      for l=1:2,
        if g(currentMachines(j),l) ~= 0,
          visited = 0;
          for m=1:length(machines),
            if (abs(g(currentMachines(j),l)-machines(m)) == 0),
              visited = 1;
              break;
            end;
          end;
          if visited == 0,
            child = currentStates(:,j);
            child(currentMachines(j)) = child(currentMachines(j)) - 1;
            child(g(currentMachines(j),l))=child(g(currentMachines(j),l)) + 1;
            nextStates = [nextStates child];
            nextMachines = [nextMachines g(currentMachines(j),l)];
            if (i == 1),
              nextFather = [nextFather l];
            else
              nextFather = [nextFather currentFather(j)];
            end;
            if (child(g(currentMachines(j),l)) - x(minIndex,k)) == 1,
              nextCost = [nextCost 0];
              skip = 1;
              break;
            else          
              nextCost = [nextCost currentCost(j)+sum(abs(child-xf))];
            end;
          end;
        end;
      end;  
    end;
    currentStates = nextStates; 
    currentMachines = nextMachines;
    currentCost = nextCost;
    currentFather = nextFather;
    machines = [machines currentMachines]; 
    states = [states currentStates];
    nextStates = []; 
    nextMachines = [];
    nextCost = [];
    nextFather = [];
  end;
  k = k + 1;
  x(:,k) = x(:,k-1);
  x(maxIndex,k) = x(maxIndex,k) - 1;
  [dum,minIndex] = min(currentCost); 
  x(g(maxIndex,currentFather(minIndex)),k) = ...
                     x(g(maxIndex,currentFather(minIndex)),k) + 1;
  if (max(abs(xf-x(:,k))) == 1) & (sum(abs(xf-x(:,k))) == Le), 
    done = 1;
  elseif (max(abs(xf-x(:,k))) == 0) & (Le == 0), 
    done = 1;
  end;
%x(:,k)'
%pause
end;

%size_x = size(x)
%xf = x(:,k)
x
diary off;
